/***************************************************************************
 *	 Copyright (C) 2006 by Thomas Keller								   *
 *	 me@thomaskeller.biz												   *
 *																		   *
 *	 This program is free software; you can redistribute it and/or modify  *
 *	 it under the terms of the GNU General Public License as published by  *
 *	 the Free Software Foundation; either version 2 of the License, or	   *
 *	 (at your option) any later version.								   *
 *																		   *
 *	 This program is distributed in the hope that it will be useful,	   *
 *	 but WITHOUT ANY WARRANTY; without even the implied warranty of		   *
 *	 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the		   *
 *	 GNU General Public License for more details.						   *
 *																		   *
 *	 You should have received a copy of the GNU General Public License	   *
 *	 along with this program; if not, write to the						   *
 *	 Free Software Foundation, Inc.,									   *
 *	 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.			   *
 ***************************************************************************/

#ifndef BRANCHES_H
#define BRANCHES_H

#include "AutomateCommand.h"
#include "TreeBuilder.h"

#include <QStringList>
#include <QAbstractItemModel>

class Branches : public QAbstractItemModel, public AutomateCommand
{
    Q_OBJECT
public:
    Branches(QObject *, const DatabaseFile &, bool);
    virtual ~Branches();

    // needed Qt Model methods
    QVariant data(const QModelIndex &, int) const;
    QVariant headerData(int, Qt::Orientation, int) const;
    QModelIndex index(int, int, const QModelIndex &) const;
    QModelIndex parent(const QModelIndex &) const;
    int rowCount(const QModelIndex &) const;
    int columnCount(const QModelIndex &) const;

public slots:
    void readBranches();

signals:
    void branchesRead(void);

private:
    void processTaskResult(const MonotoneTask &);
    QStandardItem * getBranchItem(int row, int column, const QModelIndex & index) const;
    QStandardItem * branchFromIndex(const QModelIndex & index) const;

    bool tree;
    TreeBuilder * builder;
    QStandardItemModel branches;
    DatabaseFile databaseFile;
};

#endif
