/***************************************************************************
 *   Copyright (C) 2006 by Jean-Louis Fuchs                                 *
 *   ganwell@fangorn.ch                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef GETBRANCHLOG_H
#define GETBRANCHLOG_H

#include "Ancestors.h"
#include "Select.h"
#include "Toposort.h"

class GetBranchLog : public QObject
{
    Q_OBJECT
public:
    GetBranchLog(QObject *, const DatabaseFile &, const QString &);
    ~GetBranchLog();

signals:
    void branchLogRead(const QString &, const QStringList &);

private:
    QString branch;
    DatabaseFile databaseFile;
    QStringList revisions;
    Select * selectModel;
    Toposort * revSortModel;
    Ancestors * ancestorModel;

private slots:
    void selectionReady();
    void revisionsReady();
};

#endif

