/***************************************************************************
*   Copyright (C) 2006 by Ingo Maindorfer								   *
*   ingo@liquidcooling.de												   *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#include "GetFileProxyModel.h"
#include "GetFile.h"

GetFileProxyModel::GetFileProxyModel(QObject * parent)
    : QSortFilterProxyModel(parent), version(Both)
{}

GetFileProxyModel::~GetFileProxyModel() {}

bool GetFileProxyModel::filterAcceptsRow(int sourceRow, const QModelIndex & sourceParent) const
{
    QModelIndex index = sourceModel()->index(sourceRow, 0, sourceParent);
    ContentLine * line = static_cast<ContentLine *>(index.internalPointer());

    if (line->marker == ContentLine::Added && version == Left)
        return false;
    if (line->marker == ContentLine::Removed && version == Right)
        return false;
    return true;
}

void GetFileProxyModel::setFileVersion(FileVersion v)
{
    if (version == v) return;
    version = v;
    clear();
}

GetFileProxyModel::FileVersion GetFileProxyModel::fileVersion() const
{
    return version;
}

