/***************************************************************************
 *   Copyright (C) 2006 by Ingo Maindorfer								   *
 *   ingo@liquidcooling.de												   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef GETFILEPROXYMODEL_H
#define GETFILEPROXYMODEL_H

#include <QSortFilterProxyModel>

class GetFileProxyModel : public QSortFilterProxyModel
{

public:
    explicit GetFileProxyModel(QObject *);
    ~GetFileProxyModel();
    bool filterAcceptsRow(int, const QModelIndex &) const;

    enum FileVersion { Left, Right, Both };

    void setFileVersion(FileVersion);
    FileVersion fileVersion() const;

private:
    FileVersion version;
};

#endif
