/***************************************************************************
 *   Copyright (C) 2006 by Ingo Maindorfer								   *
 *   ingo@liquidcooling.de												   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef INVENTORYPROXYMODEL_H
#define INVENTORYPROXYMODEL_H

#include <QSortFilterProxyModel>

class InventoryProxyModel : public QSortFilterProxyModel
{
    Q_OBJECT
public:
    enum ViewOption { All = 0, Changed, ContentsChanged, AttributesChanged,
                      Added, Dropped, Renamed, Missing, Unknown, Ignored,
                      Invalid };

    InventoryProxyModel(QObject *, bool);
    ~InventoryProxyModel();
    bool filterAcceptsRow(int, const QModelIndex &) const;
    bool lessThan(const QModelIndex &, const QModelIndex &) const;
    void sort(int, Qt::SortOrder order = Qt::AscendingOrder);

public slots:
    void setHideIgnoredFiles(bool);
    void setViewOption(int);

private:
    bool folderTree;
    int sortColumn;
    bool hideIgnored;
    ViewOption viewOption;
    Qt::SortOrder sortOrder;
};

#endif
