/***************************************************************************
 *   Copyright (C) 2007 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef WORKSPACE_COMMITTER_H
#define WORKSPACE_COMMITTER_H

#include "vocab.h"

#include <QDir>
#include <QMap>

//
// TODO: we should make this class working asynchronously and work
// nicely together with QProgressDialog (i.e. subclass it from QThread)
//
class WorkspaceCommitter : public QObject
{
    Q_OBJECT
public:
    WorkspaceCommitter(const WorkspacePath &);
    ~WorkspaceCommitter();

    bool run(const QString &, const QString &, const QString &, const QString &);
    inline QString getRevisionId() const { return revisionId; }

private:
    bool getChangedFiles(const QString &, QMap<QString, QPair<QString, QString> > &);
    bool putFile(const QString &, const QString &, const QString &);
    bool putCert(const QString &, const QString &, const QString &, const QString &);
    bool writeRevision(const QString &);
    bool writeOptions(const QMap<QString, QString> &);

    QString revisionId;
    WorkspacePath workspacePath;
};

#endif
