/***************************************************************************
*   Copyright (C) 2007 by Thomas Keller                                   *
*   me@thomaskeller.biz                                                   *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifndef PLATFORM_H
#define PLATFORM_H

#include <QString>

class Platform
{
public:
  /**
   * Opens a file or URL with the default registered handler
   * The URL is assumed to be valid. No security checks are performed.
   * @arg QWidget *widget The parent to the browser. This is
   * not used on some platforms.
   *  @arg const string &filename The URL to open.
   */
  static bool openFile(const QString & filename);
  /**
   * Returns the name of the currently logged in user of the system
   */
  static QString getUsername();
};

#endif

