/***************************************************************************
 *   Copyright (C) 2006 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TREE_VIEW_H
#define TREE_VIEW_H

#include <QTreeView>
#include <QContextMenuEvent>

class TreeView : public QTreeView
{
    Q_OBJECT
public:
    TreeView(QWidget *);
    TreeView(QWidget *, const QString &);
    ~TreeView();
    virtual void setModel(QAbstractItemModel *);
    void init();

public slots:
    void expandAllNodes(bool);

signals:
    void contextMenuRequested(const QModelIndexList &, const QPoint &);

private:
    void saveHeaderViewState();
    bool stateLoaded;
    void contextMenuEvent(QContextMenuEvent *);
};

#endif
