/***************************************************************************
 *   Copyright (C) 2007 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "WorkspaceFloater.h"
#include "IconProvider.h"

#include <QStyle>

WorkspaceFloater::WorkspaceFloater(QWidget * parent) : QDockWidget(parent)
{
    QWidget * parentWidget = new QWidget(this);
    setupUi(parentWidget);
    setWidget(parentWidget);

    IconProvider * icons = IconProvider::singleton();
    QStyle * style = QApplication::style();
    int iconSize = style->pixelMetric(QStyle::PM_ListViewIconSize);

    labelIconKnown->setPixmap(icons->getFileIcon("default").pixmap(iconSize));
    labelIconContentsChanged->setPixmap(icons->getFileIcon("cont_changed").pixmap(iconSize));
    labelIconAttributesChanged->setPixmap(icons->getFileIcon("attr_changed").pixmap(iconSize));
    labelIconContentsAttributesChanged->setPixmap(icons->getFileIcon("cont_attr_changed").pixmap(iconSize));
    labelIconAdded->setPixmap(icons->getFileIcon("added").pixmap(iconSize));
    labelIconDropped->setPixmap(icons->getFileIcon("dropped").pixmap(iconSize));
    labelIconRenamed->setPixmap(icons->getFileIcon("renamed").pixmap(iconSize));
    labelIconIgnored->setPixmap(icons->getFileIcon("ignored").pixmap(iconSize));
    labelIconUnknown->setPixmap(icons->getFileIcon("unknown").pixmap(iconSize));
    labelIconMissing->setPixmap(icons->getFileIcon("missing").pixmap(iconSize));
    labelIconInvalid->setPixmap(icons->getFileIcon("invalid").pixmap(iconSize));

    setWindowTitle(tr("Icon help"));
    setFloating(true);
    setVisible(false);
    setAllowedAreas(Qt::LeftDockWidgetArea | Qt::RightDockWidgetArea);
}

WorkspaceFloater::~WorkspaceFloater() {}

