/***************************************************************************
 *   Copyright (C) 2007 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef WORKSPACE_MENU_BAR_H
#define WORKSPACE_MENU_BAR_H

#include "DatabaseMenuBar.h"

class WorkspaceMenuBar : public DatabaseMenuBar
{
    Q_OBJECT
public:
    WorkspaceMenuBar(QWidget *);
    ~WorkspaceMenuBar();

    void addDockWidgetAction(QAction * action);

signals:
    void hideIgnoredFiles(bool);
    void expandTree(bool);
    void filterFiles(int);

    void showUpdateWorkspace();
    void showCommitRevision();
    void reloadWorkspace();
    void showUnaccountedRenames();

protected:
    QAction * actionHide_ignored_files;
    QAction * actionExpand_tree;
    QAction * actionAll_files;
    QAction * actionAll_changed_files;
    QAction * actionChangedContent_files;
    QAction * actionChangedAttributes_files;
    QAction * actionAdded_files;
    QAction * actionRemoved_files;
    QAction * actionRenamed_files;
    QAction * actionMissing_files;
    QAction * actionUnknown_files;
    QAction * actionIgnored_files;
    QAction * actionInvalid_files;

    QAction * actionUpdate_workspace;
    QAction * actionCommit_revision;
    QAction * actionReload_workspace;
    QAction * actionFind_unaccounted_renames;

    QMenu * menuView;
    QMenu * menuShow;
    QMenu * menuWorkspace;
    QMenu * menuDockWidgets;

private slots:
    void toggleExpandTree();
    void toggleHideIgnoredFiles();
    void toggleFilterFiles(QAction *);
};

#endif

