/***************************************************************************
 *   Copyright (C) 2006 by Jean-Louis Fuchs                                 *
 *   ganwell@fangorn.ch                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef CHANGESET_BROWSER_H
#define CHANGESET_BROWSER_H

#include "ui_changeset_browser.h"
#include "Branches.h"
#include "Dialog.h"
#include "ChangesetModel.h"
#include "GetRevision.h"

class ChangesetBrowser : public Dialog, private Ui::ChangesetBrowser
{
    Q_OBJECT
public:
    ChangesetBrowser(QWidget *, const DatabaseFile &);
    ~ChangesetBrowser();

signals:
    void revisionManifest(const QString &);

private slots:
    void branchesClicked(const QModelIndex &);
    void changesetsClicked(const QModelIndex &);
    void branchesRead();
    void toggleTree();
    void receiveAll();
    void receiveMore();
    void changesetsDoubleClicked(const QModelIndex &);
    void contextMenuRequested(const QModelIndexList &, const QPoint &);

private:
    void initTreeWidget();

    bool tree;
    DatabaseFile databaseFile;
    Branches * branchModel;
    ChangesetModel * changesetModel;
    GetRevision * revisionModel;
};

#endif

