/***************************************************************************
 *   Copyright (C) 2006 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef COMMIT_REVISION_H
#define COMMIT_REVISION_H

#include "Dialog.h"
#include "ui_commit_revision.h"
#include "GetRevision.h"

class CommitRevision : public Dialog, private Ui::CommitRevision
{
    Q_OBJECT

public:
    CommitRevision(QWidget *, const WorkspacePath &);
    ~CommitRevision();

public slots:
    void readWorkspaceRevision();

signals:
    void revisionCommitted(const QString &);

private:
    GetRevision * revModel;
    WorkspacePath workspacePath;

private slots:
    void setChangelogEntryFromList(int);
    void revisionRead();
    void accept();
};

#endif
