/***************************************************************************
 *   Copyright (C) 2006 by Ingo Maindorfer                                 *
 *   ingo@liquidcooling.de                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef KEYMANAGEMENT_H
#define KEYMANAGEMENT_H

#include "Keys.h"
#include "Dialog.h"
#include "ui_key_management.h"

#include <QMenu>
#include <QContextMenuEvent>

class KeyManagement : public Dialog, private Ui::KeyManagement
{
    Q_OBJECT
public:
    KeyManagement(QWidget *, const DatabaseFile &);
    ~KeyManagement();

public slots:
    void readKeys();

signals:
    void generateKeypair();

private:
    void contextMenuEvent(QContextMenuEvent *);
    Key * getKeyFromSelection() const;

    Keys * model;
    QMenu * popupMenu;
    DatabaseFile databaseFile;

private slots:
    void copyKeyNameToClipboard();
    void copyPubkeyHashToClipboard();
    void copyPubkeyDataToClipboard();
};

#endif
