/***************************************************************************
 *   Copyright (C) 2007 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "OpenPrompt.h"

#include <QFileDialog>

OpenPrompt::OpenPrompt(QWidget * parent) : Dialog(parent)
{
    setupUi(this);
    Dialog::init();

    connect(
        btnOpenDatabase, SIGNAL(clicked()),
        this, SLOT(openDatabase())
    );

    connect(
        btnOpenWorkspace, SIGNAL(clicked()),
        this, SLOT(openWorkspace())
    );

    connect(
        btnExit, SIGNAL(clicked()),
        this, SIGNAL(quitApp())
    );

    connect(
        this, SIGNAL(rejected()),
        this, SIGNAL(quitApp())
    );
}

OpenPrompt::~OpenPrompt() {};

void OpenPrompt::openDatabase()
{
    QString fn = QFileDialog::getOpenFileName(
        this,
        tr("Select your database..."),
        QString(),
        tr("monotone Databases (*.mtn *.db)")
    );

    if (fn.isEmpty()) return;

    emit loadDatabase(fn);
}

void OpenPrompt::openWorkspace()
{
    QString fn = QFileDialog::getExistingDirectory(
        this,
        tr("Select your workspace...")
    );

    if (fn.isEmpty()) return;

    emit loadWorkspace(fn);
}

