/***************************************************************************
 *   Copyright (C) 2007 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef UPDATE_WORKSPACE_H
#define UPDATE_WORKSPACE_H

#include "Dialog.h"
#include "ui_update_workspace.h"
#include "Select.h"
#include "Branches.h"
#include "Tags.h"

#include <QCompleter>

class UpdateWorkspace : public Dialog, private Ui::UpdateWorkspace
{
    Q_OBJECT
public:
    UpdateWorkspace(QWidget *, const WorkspacePath &);
    ~UpdateWorkspace();
    inline QString getSelectedRevision() const { return selectedRevisionId; }

public slots:
    void setSelectedRevision(const QString &);

signals:
    void selectRevisionFromSelector(const QString &);

private:
    Branches    * branchesModel;
    Tags        * tagsModel;
    QCompleter  * selectorCompleter;
    QString       selectedRevisionId;
    WorkspacePath workspacePath;

private slots:
    void slotSelectRevision();
    void accept();
    void selectBranchOption();
    void selectTagOption();
    void selectSelectorOption();
};

#endif
