/***************************************************************************
 *   Copyright (C) 2007 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef WORKSPACE_DIALOG_MANAGER_H
#define WORKSPACE_DIALOG_MANAGER_H

#include "DatabaseDialogManager.h"
#include "CommitRevision.h"
#include "UnaccountedRenames.h"
#include "UpdateWorkspace.h"

#include <QMap>
#include <QStack>

class WorkspaceDialogManager : public DatabaseDialogManager
{
    Q_OBJECT
public:
    WorkspaceDialogManager(QWidget *);
    ~WorkspaceDialogManager();

    void init(const WorkspacePath &);

    //! delegated signals
signals:
    void revisionCommitted(const QString &);

public slots:
    void showCommitRevision();
    void showUnaccountedRenames(const QMap<FileEntry, FileEntryList> &);
    void showUpdateWorkspace();
    void showFileDiff(const QString &);
    void showFileDiff(const QString &, const QString &, const QString &);
    void showFileHistory(const QString &);
    void showRevisionDiff(const QString &, const QString &, const QString &);

    void closeAllDialogs();

protected:
    CommitRevision      * commitRevision;
    UnaccountedRenames  * unaccountedRenames;
    UpdateWorkspace     * updateWorkspace;

private:
    void cleanup();

    WorkspacePath workspacePath;
};

#endif
